package vezerles;

import hengeresCsomag.AbsztraktAlakzat;
import hengeresCsomag.Cso;
import hengeresCsomag.Henger;
import hengeresCsomag.Rud;
import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.ArrayList;
import java.util.logging.Level;
import java.util.logging.Logger;

public class Vezerlo {

    private ArrayList<AbsztraktAlakzat> alakzatok = new ArrayList<AbsztraktAlakzat>();
    private String fileName = "proba.dat";

    public static void main(String[] args) {
        new Vezerlo().start();
    }

    public Vezerlo() {

    }

    private void start() {
        letrehoz();
//        fajlba();
//        fajlbol();
        kepernyore();
    }

    private void letrehoz() {
        double sugar = 10, magassag = 5;
        double suruseg = 2;
        double belsoSugar = 3;
        Henger h = new Henger(sugar, magassag);
        alakzatok.add(h);
        Rud r = new Rud(sugar, magassag, suruseg);
        alakzatok.add(r);
        Cso cs = new Cso(sugar, magassag, suruseg, belsoSugar);
        alakzatok.add(cs);
    }

    private void fajlba() {
        try {
            FileOutputStream fileOut = new FileOutputStream(fileName);
            try (ObjectOutputStream objOut = new ObjectOutputStream(
                    new BufferedOutputStream(fileOut))) {
                try {
                    objOut.writeObject(alakzatok);
                } catch (IOException ex) {
                    Logger.getLogger(Vezerlo.class.getName()).log(Level.SEVERE, null, ex);
                }
            }
        } catch (IOException ex) {
            Logger.getLogger(Vezerlo.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    private void kepernyore() {

        for (AbsztraktAlakzat a : alakzatok) {
            System.out.println(a);

        }
    }

      private void fajlbol() {
        FileInputStream fin = null; 
        {
            ObjectInputStream oin = null;
            try {
                fin = new FileInputStream(fileName);
                oin = new ObjectInputStream(new BufferedInputStream(fin));
                try {
                    alakzatok =  (ArrayList<AbsztraktAlakzat>) oin.readObject();
                } catch (ClassNotFoundException ex) {
                    Logger.getLogger(Vezerlo.class.getName()).log(Level.SEVERE, null, ex);
                }
                oin.close();
            } catch (FileNotFoundException ex) {
                Logger.getLogger(Vezerlo.class.getName()).log(Level.SEVERE, null, ex);

            } catch (IOException ex) {
                Logger.getLogger(Vezerlo.class.getName()).log(Level.SEVERE, null, ex);
            } finally {
                try {
                    fin.close();
                } catch (IOException ex) {
                    Logger.getLogger(Vezerlo.class.getName()).log(Level.SEVERE, null, ex);
                }
                try {
                    oin.close();
                } catch (IOException ex) {
                    Logger.getLogger(Vezerlo.class.getName()).log(Level.SEVERE, null, ex);
                }
            }
        }
    }


}

